<html lang="en" xmns:th="http://www.thymeleaf.org"
		xmlns:layout="http://ultraq.net.nz/thymeleaf/layout"
		layout:decorate="~{fragments/layout}">

<head>
	<title>Page Category API</title>
	
</head>

<body>
	<div layout:fragment="content">
		<h1>CATEGORY API</h1>
		<br>
		<div class="container">
		  <div class="row">
		    <div class="col-sm">
		    
		    </div>
		    <div class="col-sm">
		    	<table>
		    	<tr>
			    	<td>
				    	<button type="button" class="btn btn-primary" onclick="openModal()" >
						  Create New</button>
			    	</td>
			    	<td style='width:108px;'></td>
			    	<td><input onkeyup="searchCategory()" id="keySearch" type = 'text' placeholder="Search" value = '' ></td>
		    	</tr>
		    	</table><br>
		    	<div id="isidata"></div>
		    </div>
		    <div class="col-sm">
	
		    </div>
		  </div>
		</div>
		
		<script>
	
			$(function(){
				getAllCategory();
			})
			
			function searchCategory(){
				var key = $('#keySearch').val();
				
				if(key != 0 ){
					$.ajax({
						url: '/api/category/search/'+key+'',
						type: 'get',
						contentType: 'application/json',
						success: function (data) {
							var str = "<table border = '2' class='table' style='text-align: center;'>"
								str += "<thead>"
								str += "<tr>"
								str += "<th>Initial</th>"
								str += "<th>Nama</th>"
								str += "<th style='text-align:center'>Active</th>"
								str += "<th colspan='2' >Action</th>"
								str += "</tr>"
								str += "</thead>"
								str += "<tbody>"
								for (var i = 0; i < data.length; i++) {
									str += "<tr>"
									str += "<td>" + data[i].categoryInitial + "</td>"
									str += "<td>" + data[i].categoryName + "</td>"
									str += "<td><input type='checkbox' name='isactive' checked disabled></id>"
									str += "<td><button onclick='openModalEdit("+data[i].id+")' type='button' class='btn btn-warning'>Edit</button></td>"
									str += "<td><button onclick='openModalDelete("+data[i].id+")' type='button' class='btn btn-danger'>Delete</button></td>"
									str += "</tr>"
								}
								str += "</tbody>"
								str += "<table>"
								$('#isidata').html(str)
						}
					})
				}else{
					getAllCategory() 
				}
			}
			function getAllCategory() {
				$.ajax({
					url: '/api/category',
					type: 'get',
					contentType: 'application/json',
					success: function (data) {
						var str = "<table border = '2' class='table' style='text-align: center;'>"
						str += "<thead>"
						str += "<tr>"
						str += "<th>Initial</th>"
						str += "<th>Nama</th>"
						str += "<th style='text-align:center'>Active</th>"
						str += "<th colspan='2' >Action</th>"
						str += "</tr>"
						str += "</thead>"
						str += "<tbody>"
						for (var i = 0; i < data.length; i++) {
							str += "<tr>"
							str += "<td>" + data[i].categoryInitial + "</td>"
							str += "<td>" + data[i].categoryName + "</td>"
							str += "<td><input type='checkbox' name='isactive' checked disabled></id>"
							str += "<td><button onclick='openModalEdit("+data[i].id+")' type='button' class='btn btn-warning'>Edit</button></td>"
							str += "<td><button onclick='openModalDelete("+data[i].id+")' type='button' class='btn btn-danger'>Delete</button></td>"
							str += "</tr>"
						}
						str += "</tbody>"
						str += "<table>"
						$('#isidata').html(str)
					}
				})
			}
			
			function openModal() {
				var str = "<form>"
					str += "<input type='hidden' value=0 class = 'form-control' id='categoryId'>"
					str += "<div class = 'form-group'>"
					str += "<label>Category Initial</label>"
					str += "<input type='text' class = 'form-control' id='categoryInitial'>"
					str += "</div>"
					str += "<div class = 'form-group'>"
					str += "<label>Category Name</label>"
					str += "<input type='text' class = 'form-control' id='categoryName'>"
					str += "</div>"
					str += "<div class = 'form-group form-check'>"
					str += "<input type='checkbox' class='form-check-input' id='isActive'>"
					str += "<label>Active</Label>"
					str += "</div>"
					str += "</form>"
				
				$('#btn-save').html('Create Data')
				$('#btn-save').removeClass().addClass('btn btn-success')
				$('.modal-title').html('Category Form')
				$('.modal-body').html(str)
				$('#btn-save').off('click').on('click',saveCategory).html('Create Data')
				$('#modal').modal('show')
			}
			
			function saveCategory(){
				
				var id = $('#categoryId').val()
				var initial = $('#categoryInitial').val()
				var nama = $('#categoryName').val()
				var active = $('#isActive')[0].checked
				var link = ''
				var type =''
				if(id==0){
					link = '/api/category/add'
					type = 'post'
				}else{
					link = '/api/edit/category/'+id+''
					type = 'put'
				}
				
				var formatdata = '{'
					formatdata +='"categoryInitial":"'+initial+'",'
					formatdata +='"categoryName":"'+nama+'",'
					formatdata +='"isActive":'+active+''
					formatdata +='}'
					
				$.ajax({
					url: link,
					type: type,
					contentType:'application/json',
					data: formatdata,
					success: function(){
						$('#modal').modal('toggle')
						getAllCategory()
					}					
				})
			}
		
			function openModalEdit(id) {
				openModal();
				$.ajax({
					url: '/api/category/'+id+'',
					type: 'get',
					contentType: 'application/json',
					success: function (data){
						$('#categoryId').val(data.id)
						$('#categoryInitial').val(data.categoryInitial)
						$('#categoryName').val(data.categoryName)
						$('#isActive').prop("checked",true)
						$('#btn-save').html('Update Data')
						$('#btn-save').removeClass().addClass('btn btn-warning')
						$('.modal-title').html('Category Edit Form')
						$('#modal').modal('show')
					}
				})
			}
			
			function openModalDelete(id) {
				$.ajax({
					url: '/api/category/'+id+'',
					type: 'get',
					contentType: 'application/json',
					success: function (data){
						var str = "<form>"
							str +="<table>"
							str += "<input value='"+data.id+"' type='hidden' class = 'form-control' id='categoryId'>"
							str += "<tr>"
							str += "<td style='text-align:end'>Category Initial  </td>"
							str += "<td style='width: 10px;'></td>"
							str += "<td> "+data.categoryInitial+"</td>"
							str += "</tr>"
							str += "<tr>"
							str += "<td style='text-align:right'>Category Name  </td>"
							str += "<td style='width: 10px;'></td>"
							str += "<td> "+data.categoryName+"</td>"
							str += "</tr>"
							str += "<tr>"
							str += "<td style='text-align:end'>Active  </td>"
							str += "<td style='width: 10px;'></td>"
							str += "<td><input disabled checked type='checkbox'  id='isActive'></td>"
							str += "</tr>"
							str += "</table>"
							str += "</form>"
						
						$('#btn-save').html('Delete')
						$('#btn-save').removeClass().addClass('btn btn-danger')
						$('.modal-title').html('Delete')
						$('.modal-body').html(str)
						$('.modal-body').css("margin","auto")
						$('#btn-save').off('click').on('click',deletedata)
						$('#modal').modal('show')
					}
				})
			}
			
			function deletedata(){
				var id = $('#categoryId').val()
				$.ajax({
					url: '/api/delete/category/'+id+'',
					type: 'put',
					contentType:'application/json',
					success: function(){
						$('#modal').modal('toggle')
						getAllCategory()
					}					
				})
			}
		</script>
	</div>
	
	
</body>

</html>